leetcode题解:两数之和

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
 
题解:
利用hashmap,散列表查询较快,但耗费内存更高:
public int[] twoSum(int[] nums, int target) {
        Map<Integer,Integer> map = new HashMap<Integer,Integer>();
        for(int i = 0; i < nums.length; i++){
            int difference = target - nums[i];
            if(map.containsKey(difference) ){
                return new int[]{map.get(difference),i};
            }
             map.put(nums[i],i);
        }
        return new int[2];
    }
 
暴力循环:
时间复杂度为O(n),空间复杂度O(1)
    public int[] twoSum(int[] nums, int target) {
        for(int i = 0; i < (nums.length - 1); i++){
            for(int j = (i+1); j < nums.length ; j++){
                if((nums[i] + nums[j]) == target){
                   return new int[] { i, j };
                }
            }
        }
        return new int[2];
    }
原文地址:https://www.cnblogs.com/wangzepu/p/11389403.html